declare type Validate = (data: string | number) => boolean;
declare type NumberOrDate = number | Date;
export interface RegisterInput {
    ref: HTMLInputElement | HTMLSelectElement | null;
    required?: boolean;
    min?: NumberOrDate;
    max?: NumberOrDate;
    maxLength?: number;
    pattern?: RegExp;
    validate?: Validate | {
        [key: string]: Validate;
    };
    minLength?: number;
}
export interface Field {
    ref: any;
    required?: boolean;
    min?: NumberOrDate;
    max?: NumberOrDate;
    maxLength?: number;
    pattern?: RegExp;
    validate?: Validate | {
        [key: string]: Validate;
    };
    minLength?: number;
    eventAttached?: boolean;
    watch?: boolean;
    mutationWatcher?: any;
    options?: Array<{
        ref: any;
        eventAttached?: boolean;
        mutationWatcher?: any;
    }>;
}
export interface ErrorMessages {
    [key: string]: {
        string: boolean;
    } | {};
}
export default function useForm({ mode }?: {
    mode: 'onSubmit' | 'onBlur' | 'onChange';
}): {
    register: (data: RegisterInput) => void;
    handleSubmit: (callback: (Object: any, e: any) => void) => (e: any) => void;
    errors: ErrorMessages;
    watch: (filedNames?: string | string[], defaultValue?: string | string[]) => any;
};
export {};
